/*
 * Utility for getting PhotoInfo from view's selection.
 * Copyright (C) 2016  Michał Walenciak <Kicer86@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef SELECTIONEXTRACTOR_HPP
#define SELECTIONEXTRACTOR_HPP

#include <deque>

#include <database/iphoto_info.hpp>

class QItemSelectionModel;

class DBDataModel;

class SelectionExtractor final: public QObject
{
        Q_OBJECT

    public:
        SelectionExtractor();
        ~SelectionExtractor();

        SelectionExtractor(const SelectionExtractor &) = delete;
        SelectionExtractor& operator=(const SelectionExtractor &) = delete;

        void set(QItemSelectionModel *);
        void set(DBDataModel *);

        std::vector<IPhotoInfo::Ptr> getSelection() const;

    private:
        QItemSelectionModel* m_selectionModel;
        DBDataModel* m_photosModel;

    signals:
        void selectionChanged();
};

#endif // SELECTIONEXTRACTOR_HPP
